<div class="card">
	<div class="card-header">
		<div class="d-flex">
			<i class="fas fa-table mr-1 align-self-center"></i>
			<h5 class="card-title mb-0 flex-fill align-self-center">Listado de Solicitudes</h5>
			<app-pager-add permission="request_create"></app-pager-add>
		</div>
	</div>

	<div class="card-body">
		<app-pager-size-filter></app-pager-size-filter>

		<div class="row m-t-15">
			<div class="col-md-12">
				<ngx-datatable appPager (onPager)="getData()" #table>
					<ngx-datatable-column [resizeable]="false" [flexGrow]="2" prop="model" name="Modelo"></ngx-datatable-column>
					<ngx-datatable-column [resizeable]="false" [flexGrow]="2" prop="page" name="Pagina"></ngx-datatable-column>
					<ngx-datatable-column [resizeable]="false" [flexGrow]="2" prop="status" name="Estado"></ngx-datatable-column>

					<ngx-datatable-column [resizeable]="false" [flexGrow]="2" [sortable]="false" name="Acciones" headerClass="text-center">
						<ng-template ngx-datatable-cell-template let-row="row">
							<div class="text-center">
								<button
									type="button"
									class="btn btn-primary py-1 mr-1"
									[ngbTooltip]="'Aprobar'"
									*ngxPermissionsOnly="'request_gestor'"
									[disabled]="row.status_id === 10 || row.status_id === 11"
									(click)="approve(row)"
								>
									<i class="far fa-thumbs-up"></i>
								</button>

								<app-pager-button-edit permission="request_edit" [link]="['edit', row.id]"></app-pager-button-edit>
								<!-- <app-pager-button-edit permission="request_comment" [link]=model"['comment', row.id]"></app-pager-button-edit> -->
								<!-- <app-pager-button-delete permission="request_deny" (click)="delete(row)"></app-pager-button-delete> -->
								<button
									type="button"
									class="btn btn-success py-1 mr-1"
									[ngbTooltip]="'Comentarios'"
									*ngxPermissionsOnly="'request_comment'"
									(click)="open(row, comentariosModal)"
								>
									<i class="far fa-envelope"></i>
								</button>
								<button
									type="button"
									class="btn btn-danger py-1 mr-1"
									[ngbTooltip]="'Rechazar'"
									*ngxPermissionsOnly="'request_gestor'"
									[disabled]="row.status_id === 10 || row.status_id === 11"
									(click)="deny(row)"
								>
									<i class="far fa-thumbs-down"></i>
								</button>
							</div>
						</ng-template>
					</ngx-datatable-column>
				</ngx-datatable>
			</div>
		</div>
	</div>
</div>
<ng-template #comentariosModal let-modal>
	<app-dimmer [loading]="loading"></app-dimmer>

	<div class="modal-header">
		<h4 class="modal-title" id="modal-basic-title">Comentarios</h4>
		<button type="button" class="close" aria-label="Close" (click)="modal.dismiss()">
			<span aria-hidden="true">&times;</span>
		</button>
	</div>
	<div class="modal-body">
		<div class="row mb-3">
			<div class="col-md-4">
				<div class="label-field-col">
					<label>Modelo:</label>
					<span>{{ selected.model }}</span>
				</div>
			</div>

			<div class="col-md-4">
				<div class="label-field-col">
					<label>Página:</label>
					<span>{{ selected.page }}</span>
				</div>
			</div>

			<div class="col-md-4">
				<div class="label-field-col">
					<label>Estado:</label>
					<span>{{ selected.status }}</span>
				</div>
			</div>
		</div>

		<hr />

		<div class="form-group" [formGroup]="form">
			<label>Agregar comentario</label>
			<textarea rows="3" class="form-control form-control-sm" formControlName="comment"></textarea>
			<app-form-control-error formControlName="comment"></app-form-control-error>
			<div class="row">
				<div class="col-sm-3">
					<div class="form-group">
						<label>Estado de la solicitud:</label>
						<app-select [options]="status" formControlName="status_id_comment">
						</app-select>
						<app-form-control-error formControlName="status_id_comment"></app-form-control-error>
					</div>
				</div>
			</div>
		</div>

		<div class="text-right">
			<button type="button" class="btn btn-primary py-1 mr-1" (click)="saveComment()" [disabled]="commentDisabled">Guardar</button>
		</div>
		<ng-container *ngFor="let c of comments">
			<hr />
			<div>
				<span class="font-weight-bold mr-2">{{ c.user_name }}</span>
				<span class="small text-muted font-italic">{{ (c.created_at | amDateFormat: 'LLL') + ' | Estado: ' + c.status }}</span>
			</div>
			<span>{{ c.comment }}</span>
		</ng-container>
	</div>
</ng-template>
